org.crosswire.bibledesktop.display

## Interface BookDataDisplay

- All Superinterfaces:
    org.crosswire.jsword.book.BookProvider, EventListener, PropertyChangeListener
  All Known Implementing Classes:
    MultiBookPane, ProxyBookDataDisplay, ScrolledBookDataDisplay, TabbedBookDataDisplay, TextPaneBookDataDisplay

      public interface BookDataDisplay
      extends org.crosswire.jsword.book.BookProvider, PropertyChangeListener

  An interface for all components that can display BookData.
  Author:
    Joe Walker
  See Also:
    `for license details.`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `COMPARE_BOOKS` Used by property change listeners to listen for when books should be compared.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addKeyChangeListener(KeyChangeListener listener)` Add a listener for when the key changes.
    `void` | `addURIEventListener(URIEventListener listener)` Add a listener for when someone clicks on a browser 'link'
    `void` | `clearBookData()` Clear any BookData that is displayed.
    `void` | `copy()` Copy the selection to the clipboard
    `Component` | `getComponent()` Accessor for the Swing component
    `org.crosswire.jsword.passage.Key` | `getKey()` The Book Key that we are displaying, or null if we are not displaying anything
    `void` | `refresh()` Cause the BookData to be re-displayed.
    `void` | `removeKeyChangeListener(KeyChangeListener listener)` Remove a listener for when the key changes.
    `void` | `removeURIEventListener(URIEventListener listener)` Remove a listener for when someone clicks on a browser 'link'
    `void` | `setBookData(org.crosswire.jsword.book.Book[] books, org.crosswire.jsword.passage.Key key)` Set the BookData to be displayed.
    `void` | `setCompareBooks(boolean compare)` Establish whether books in the book array should be compared.

    - ### Methods inherited from interface org.crosswire.jsword.book.BookProvider

      `getBooks, getFirstBook`

    - ### Methods inherited from interface java.beans.PropertyChangeListener

      `propertyChange`

- - ### Field Detail

    - #### COMPARE_BOOKS

          static final String COMPARE_BOOKS

      Used by property change listeners to listen for when books should be compared.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### clearBookData

          void clearBookData()

      Clear any BookData that is displayed. This is equivalent to: `setBookData(null, null)`.

    - #### setBookData

          void setBookData(org.crosswire.jsword.book.Book[] books,
                         org.crosswire.jsword.passage.Key key)

      Set the BookData to be displayed. The data to be displayed is specified as a books and key rather than the more obvious BookData (the result of reading books using a key) since some displays may wish so split up the display and only look up smaller sections at a time.
      Parameters:
        `books` - The Books to read data from
        `key` - The key to read from the given book

    - #### setCompareBooks

          void setCompareBooks(boolean compare)

      Establish whether books in the book array should be compared.
      Parameters:
        `compare` -

    - #### getKey

          org.crosswire.jsword.passage.Key getKey()

      The Book Key that we are displaying, or null if we are not displaying anything
      Returns:
        The current key

    - #### refresh

          void refresh()

      Cause the BookData to be re-displayed.

    - #### copy

          void copy()

      Copy the selection to the clipboard

    - #### addKeyChangeListener

          void addKeyChangeListener(KeyChangeListener listener)

      Add a listener for when the key changes.
      Parameters:
        `listener` -

    - #### removeKeyChangeListener

          void removeKeyChangeListener(KeyChangeListener listener)

      Remove a listener for when the key changes.
      Parameters:
        `listener` -

    - #### addURIEventListener

          void addURIEventListener(URIEventListener listener)

      Add a listener for when someone clicks on a browser 'link'
      Parameters:
        `listener` - The listener to add

    - #### removeURIEventListener

          void removeURIEventListener(URIEventListener listener)

      Remove a listener for when someone clicks on a browser 'link'
      Parameters:
        `listener` - The listener to remove

    - #### getComponent

          Component getComponent()

      Accessor for the Swing component